<?xml version="1.0" encoding="utf-8"?>
<!--
    App optimizations device config
-->
<app-optimization version="1">

    <devconfig>
        <thermal-sensor>front_temp</thermal-sensor>
        <!-- cpu profiles from low to high
        MAX_FREQ_CLUSTER_LITTLE_CORE_0 = 0x40804100,
        MIN_FREQ_CLUSTER_LITTLE_CORE_0 = 0x40800100,
        MAX_FREQ_CLUSTER_BIG_CORE_0 = 0x40804000,
        MIN_FREQ_CLUSTER_BIG_CORE_0 = 0x40800000,
        MAX_FREQ_CLUSTER_PRIME_CORE_0 = 0x40804200,
        MIN_FREQ_CLUSTER_PRIME_CORE_0 = 0x40800200,
        GPU_MIN_PWRLVL = 0x42804000,
        SCHEDBOOST = 0x40C00000
        POWER COLLAPSE = 0x40400000,
        STORAGE CLK SCALING = 0x42C10000
        MIN_ONLINE_CPU_CLUSTER_BIG = 0x41000000
        MIN_ONLINE_CPU_CLUSTER_PRIME = 0x41000200
        DISPLAY_ON = 0x40000000
        -->
        <profile-adjuster name="0" dropFramesPC="0.95" downTimeout="2000" upFramesPC="0.92" dropJankPC="0.04" upJankPC="0.05" downCpuUtil="35" upCpuUtil="64" bypassFPS="10"/>
        <profile-adjuster name="1" dropFramesPC="0.85" downTimeout="2000" upFramesPC="0.92" dropJankPC="0.15" upJankPC="0.05" downCpuUtil="40" upCpuUtil="68" bypassFPS="10"/>
        <profile name="1">0x40804100, 1113, 0x40804000, 1190, 0x40804200, 960</profile>
        <profile name="2">0x40804100, 1113, 0x40804000, 1286, 0x40804200, 1094</profile>
        <profile name="3">0x40804100, 1228, 0x40804000, 1401, 0x40804200, 1324</profile>
        <profile name="4">0x40804100, 1344, 0x40804000, 1593, 0x40804200, 1651</profile>
        <profile name="5">0x40804100, 1344, 0x40804000, 1824, 0x40804200, 1900</profile>
        <profile name="6">0x40804100, 1478, 0x40804000, 2073, 0x40804200, 2304</profile>
        <profile name="7">0x40804100, 1478, 0x40804000, 2361, 0x40804200, 2668</profile>
        <profile name="8">0x40804100, 1593, 0x40804000, 2611, 0x40804200, 2918</profile>
        <profile name="11">0x40000000, 0, 0x40804100, 1113, 0x40804000, 1401, 0x40804200, 1324</profile>
        <profile name="12">0x40000000, 0, 0x40804100, 1344, 0x40804000, 1593, 0x40804200, 1651</profile>
        <profile name="fullscreen_video">0x40804100, 1344, 0x40804000, 1401, 0x40804200, 1651</profile>
        <profile name="mover">0x40804100, 1344, 0x40804000, 1401, 0x40804200, 1651</profile>
        <profile name="heavy">0x40400000, 1, 0x42C10000, 1</profile>
        <profile name="heavy_lite">0x42C10000, 1</profile>
        <profile name="cert_app_boost">0x40804000, 0xFFF, 0x40804100, 0xFFF, 0x40804200, 0xFFF, 0x40800000, 0xFFF, 0x40800100, 0xFFF, 0x40800200, 0xFFF</profile>
        <brightness level="60" autorr="120, 60, 30, 24" display="0"/> <!-- 60 nit -->
        <brightness level="40" autorr="90" display="0"/> <!-- 40 nit -->
        <brightness level="60" autorr="120, 60, 30, 24" display="1"/> <!-- 60 nit -->
        <brightness level="40" autorr="90" display="1"/> <!-- 40 nit -->
    </devconfig>

    <!-- classified apps -->
    <optimization name="base_app">
        <supported-modes>video_mode, video_fullscreen_mode, camera_mode</supported-modes>
        <profile-adjuster>0</profile-adjuster>
        <limit temp="0" tempClr="-20" profile="1-8"/>
        <limit temp="41" tempClr="39" profile="1-8" rr="90"/>
        <limit temp="44" tempClr="42" profile="1-4" thermalrr="60"/>
    </optimization>

    <optimization name="rr_opt_app" parent="base_app">
        <default-rr>auto</default-rr>
    </optimization>

    <optimization name="rr_limit_app" parent="rr_opt_app">
        <limit temp="0" tempClr="-20" profile="1-8" rr="90"/>
        <limit temp="44" tempClr="42" profile="1-4" thermalrr="60"/>
    </optimization>

    <optimization name="rr_extra_app" parent="rr_limit_app">
    </optimization>

    <optimization name="navigation_app" parent="rr_opt_app">
        <idle-fps>30</idle-fps>
        <profile-adjuster>1</profile-adjuster>
        <maxe-profile>aba</maxe-profile>
    </optimization>

    <optimization name="reading_app" parent="rr_opt_app">
        <idle-fps>30</idle-fps>
        <maxe-profile>aba</maxe-profile>
    </optimization>

    <optimization name="rr_deep_opt_app" parent="rr_opt_app">
        <min-fps>30</min-fps>
    </optimization>

    <optimization name="low_latency_app" parent="rr_opt_app">
        <llm>true</llm>
    </optimization>

    <optimization name="settings_app" parent="base_app">
        <limit temp="0" tempClr="-20" profile="1-6"/>
        <limit temp="41" tempClr="39" profile="1-6" rr="90"/>
        <limit temp="44" tempClr="42" profile="1-6" rr="60"/>
    </optimization>

    <optimization name="mover" parent="rr_opt_app">
        <profile-adjuster remove-tag="true"/>
        <limit temp="0" tempClr="-20" profile="mover" rr="90"/>
        <limit temp="44" tempClr="42" profile="mover" thermalrr="60"/>
        <thermal>mover</thermal>
    </optimization>

    <optimization name="browsing_app" parent="base_app">
        <maxe-profile>aba</maxe-profile>
    </optimization>

    <optimization name="teams_app" parent="low_latency_app">
        <maxe-profile>aba</maxe-profile>
    </optimization>

    <optimization name="normal_app" parent="base_app">
    </optimization>

    <optimization name="heavy_load_app">
        <boost rr="120" profile="heavy"/>
        <thermal>perf</thermal>
    </optimization>

    <optimization name="heavy_load_app_5">
        <boost rr="120" profile="heavy_lite"/>
        <thermal>perf</thermal>
    </optimization>

    <optimization name="heavy_load_lite_app">
        <boost profile="heavy_lite"/>
        <thermal>perf</thermal>
    </optimization>

    <optimization name="cert_app">
        <boost profile="cert_app_boost"/>
        <thermal>perf</thermal>
    </optimization>

    <!-- recognized in-app modes, will merge with app opt at runtime -->
    <optimization name="video_mode">
        <default-rr>auto</default-rr>
    </optimization>

    <optimization name="video_fullscreen_mode">
        <default-rr>video</default-rr>
        <limit temp="0" tempClr="-20" profile="1-5"/>
        <limit temp="40" tempClr="38" profile="1-4" thermalrr="90"/>
        <limit temp="43" tempClr="41" profile="1-3" thermalrr="60"/>
    </optimization>

    <optimization name="camera_mode">
        <default-rr remove-tag="true"/>
        <maxe-profile remove-tag="true"/>
        <limit remove-tag="true"/>
        <thermal>camera</thermal>
    </optimization>

    <!-- global modes -->
    <optimization name="cli_open_mode">
        <thermal>cli</thermal>
    </optimization>

    <optimization name="fast_charging_mode">
        <thermal>fastc</thermal>
    </optimization>

    <optimization name="wireless_charging_mode">
        <thermal>wl</thermal>
    </optimization>

    <optimization name="battery_low_mode">
        <limit rr="90"/>
    </optimization>

    <optimization name="device_hot_mode">
        <limit temp="0" tempClr="-20" profile="12"/>
        <limit temp="38" tempClr="36" profile="11"/>
    </optimization>

    <optimization name="bright_throttle_mode">
        <limit temp="48" tempClr="42" brt-throttle="0:800"/>
        <limit temp="49" tempClr="43" brt-throttle="0:700"/>
        <limit temp="50" tempClr="44" brt-throttle="0:500"/>
        <limit temp="51" tempClr="45" brt-throttle="0:200"/>
    </optimization>

    <!-- optimizations -->
    <optimization name="com.netease.newsreader.activity" refs="rr_opt_app" />
    <optimization name="com.sohu.newsclient" refs="rr_opt_app" />
    <optimization name="com.reddit.frontpage" refs="reading_app" />
    <optimization name="com.qidian.QDReader" refs="reading_app" />
    <optimization name="com.chaozh.iReaderFree" refs="reading_app" />
    <optimization name="us.zoom.videomeetings" refs="low_latency_app" />

    <optimization name="com.motorola.cn.devicemigration" refs="mover" />

    <optimization name="com.android.settings" refs="settings_app" />
    <optimization name="com.motorola.coresettingsext" refs="settings_app" />

    <optimization name="com.android.chrome" refs="browsing_app" />
    <optimization name="org.mozilla.firefox" refs="browsing_app" />
    <optimization name="com.brave.browser" refs="browsing_app" />
    <optimization name="om.opera.browser" refs="browsing_app" />
    <optimization name="com.microsoft.emmx" refs="browsing_app" />
    <optimization name="com.UCMobile" refs="browsing_app" />
    <optimization name="com.zui.browser" refs="browsing_app" />
    <optimization name="com.tencent.mtt" refs="browsing_app" />
    <optimization name="com.quark.browser" refs="browsing_app" />

    <optimization name="com.microsoft.teams" refs="teams_app" />

    <optimization name="org.chromium.latency.walt" refs="cert_app" />

    <optimization name="com.eg.android.AlipayGphone" refs="rr_extra_app" />
    <optimization name="cn.soulapp.android" refs="rr_extra_app" />

</app-optimization>
